## git-annex 5.20150731

=== debian/changelog ===
git-annex (5.20150731-1build1) wily; urgency=medium

  * No-change rebuild against libicu55

 -- Steve Langasek <steve.langasek@ubuntu.com>  Fri, 07 Aug 2015 01:29:36 +0000

git-annex (5.20150731-1) unstable; urgency=medium

  * Package 5.20150731

 -- Richard Hartmann <richih@debian.org>  Tue, 04 Aug 2015 23:41:14 +0200

git-annex (5.20150731) unstable; urgency=medium

  * webapp: Support enabling known gitlab.com remotes.
  * Fix rsync special remote to work when -Jn is used for concurrent
    uploads.
  * The last release accidentially removed a number of options from the
    copy command. (-J, file matching options, etc). These have been added
    back.
  * init: Detect when the filesystem is crippled such that it ignores
    attempts to remove the write bit from a file, and enable direct mode.
    Seen with eg, NTFS fuse on linux.
  * Fix man page installation by cabal install; all the new man pages are
    now installed.

 -- Joey Hess <id@joeyh.name>  Fri, 31 Jul 2015 11:34:36 -0400

=== debian/control ===
Source: git-annex
Section: utils
Priority: optional
Build-Depends: 
	debhelper (>= 9),
	ghc (>= 7.4),
	libghc-mtl-dev (>= 2.1.1),
	libghc-missingh-dev,
	libghc-data-default-dev,
	libghc-hslogger-dev,
	libghc-pcre-light-dev,
	libghc-cryptohash-dev (>= 0.11.0),
	libghc-sandi-dev,
	libghc-utf8-string-dev,
	libghc-aws-dev (>= 0.9.2-2~),
	libghc-conduit-dev,
	libghc-resourcet-dev,
	libghc-quickcheck2-dev,
	libghc-monad-control-dev (>= 0.3),
	libghc-exceptions-dev (>= 0.6),
	libghc-transformers-dev,
	libghc-unix-compat-dev,
	libghc-dlist-dev,
	libghc-uuid-dev,
	libghc-json-dev,
	libghc-aeson-dev,
	libghc-ifelse-dev,
	libghc-bloomfilter-dev,
	libghc-edit-distance-dev,
	libghc-hinotify-dev [linux-any],
	libghc-stm-dev (>= 2.3),
	libghc-dbus-dev (>= 0.10.7) [linux-any],
	libghc-fdo-notify-dev (>= 0.3) [linux-any],
	libghc-yesod-dev (>= 1.2.6.1)       [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-yesod-core-dev (>= 1.2.19)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-yesod-form-dev (>= 1.3.15)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-yesod-static-dev (>= 1.2.4)  [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-yesod-default-dev (>= 1.2.0) [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-shakespeare-dev (>= 2.0.0)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-clientsession-dev            [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-warp-dev (>= 3.0.0.5)        [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-warp-tls-dev                 [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-wai-dev                      [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-wai-extra-dev                [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-dav-dev (>= 1.0)             [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-persistent-dev               [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-persistent-template-dev      [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-persistent-sqlite-dev        [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-esqueleto-dev                [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
	libghc-securemem-dev,
	libghc-byteable-dev,
	libghc-dns-dev,
	libghc-case-insensitive-dev,
	libghc-http-types-dev,
	libghc-http-conduit-dev,
	libghc-blaze-builder-dev,
	libghc-crypto-api-dev,
	libghc-network-multicast-dev,
	libghc-network-info-dev [linux-any kfreebsd-any],
	libghc-safesemaphore-dev,
	libghc-network-protocol-xmpp-dev (>= 0.4.3-1+b1),
	libghc-gnutls-dev (>= 0.1.4),
	libghc-xml-types-dev,
	libghc-async-dev,
	libghc-monad-logger-dev,
	libghc-feed-dev (>= 0.3.9.2),
	libghc-regex-tdfa-dev,
	libghc-tasty-dev (>= 0.7),
	libghc-tasty-hunit-dev,
	libghc-tasty-quickcheck-dev,
	libghc-tasty-rerun-dev,
	libghc-optparse-applicative-dev (>= 0.10),
	libghc-cabal-dev,
	lsof [linux-any],
	ikiwiki,
	perlmagick,
	git (>= 1:1.8.1),
	rsync,
	wget,
	curl,
	openssh-client,
	git-remote-gcrypt (>= 0.20130908-6),
Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
XSBC-Original-Maintainer: Richard Hartmann <richih@debian.org>
Standards-Version: 3.9.6
Vcs-Git: git://git.kitenet.net/git-annex
Homepage: http://git-annex.branchable.com/
XS-Testsuite: autopkgtest

Package: git-annex
Architecture: any
Section: utils
Depends: ${misc:Depends}, ${shlibs:Depends},
	git (>= 1:1.8.1),
	rsync,
	wget,
	curl,
	openssh-client (>= 1:5.6p1)
Recommends: 
	lsof,
	gnupg,
	bind9-host,
	quvi,
	git-remote-gcrypt (>= 0.20130908-6),
	nocache,
	aria2,
	bittornado | bittorrent,
Suggests:
	graphviz,
	bup,
	tahoe-lafs,
	libnss-mdns,
Description: manage files with git, without checking their contents into git
 git-annex allows managing files with git, without checking the file
 contents into git. While that may seem paradoxical, it is useful when
 dealing with files larger than git can currently easily handle, whether due
 to limitations in memory, time, or disk space.
 .
 It can store large files in many places, from local hard drives, to a
 large number of cloud storage services, including S3, WebDAV,
 and rsync, with a dozen cloud storage providers usable via plugins.
 Files can be stored encrypted with gpg, so that the cloud storage
 provider cannot see your data. git-annex keeps track of where each file
 is stored, so it knows how many copies are available, and has many
 facilities to ensure your data is preserved.
 .
 git-annex can also be used to keep a folder in sync between computers,
 noticing when files are changed, and automatically committing them
 to git and transferring them to other computers. The git-annex webapp
 makes it easy to set up and use git-annex this way.

## git-annex 5.20150812

=== Makefile ===
mans=$(shell find doc -maxdepth 1 -name git-annex*.mdwn | sed -e 's/^doc/man/' -e 's/\.mdwn/\.1/')
all=git-annex mans docs

CABAL?=cabal # set to "./Setup" if you lack a cabal program
GHC?=ghc

PREFIX?=/usr
SHAREDIR?=share

# Am I typing :make in vim? Do a fast build.
ifdef VIM
all=fast
endif

build: $(all)

Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
	if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
	$(CABAL) configure

git-annex: Build/SysConfig.hs
	$(CABAL) build
	ln -sf dist/build/git-annex/git-annex git-annex

man/%.1: doc/%.mdwn
	./Build/mdwn2man $@ 1 $< > $@

# These are not built normally.
git-union-merge.1: doc/git-union-merge.mdwn
	./Build/mdwn2man git-union-merge 1 doc/git-union-merge.mdwn > git-union-merge.1
git-union-merge:
	$(GHC) --make -threaded $@

install-mans: mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1
	install -m 0644 $(mans) $(DESTDIR)$(PREFIX)/$(SHAREDIR)/man/man1

install-docs: docs install-mans
	install -d $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex
	if [ -d html ]; then \
		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex/html/; \
	fi

install: build install-docs Build/InstallDesktopFile
	install -d $(DESTDIR)$(PREFIX)/bin
	install git-annex $(DESTDIR)$(PREFIX)/bin
	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true
	install -d $(DESTDIR)$(PREFIX)/share/bash-completion/completions
	install -m 0644 bash-completion.bash $(DESTDIR)$(PREFIX)/share/bash-completion/completions/git-annex

test: git-annex
	./git-annex test

retest: git-annex
	./git-annex test --rerun-update --rerun-filter failures

# hothasktags chokes on some template haskell etc, so ignore errors
tags:
	(for f in $$(find . | grep -v /.git/ | grep -v /tmp/ | grep -v /dist/ | grep -v /doc/ | egrep '\.hs$$'); do hothasktags -c --cpp -c -traditional -c --include=dist/build/autogen/cabal_macros.h $$f; done) 2>/dev/null | sort > tags

# If ikiwiki is available, build static html docs suitable for being
# shipped in the software package.
ifeq ($(shell which ikiwiki),)
IKIWIKI=echo "** ikiwiki not found, skipping building docs" >&2; true
else
IKIWIKI=ikiwiki
endif

mans: man $(mans)

man:
	mkdir -p man

docs: mans
	LC_ALL=C TZ=UTC $(IKIWIKI) doc html -v --wikiname git-annex \
		--plugin=goodstuff \
		--no-usedirs --disable-plugin=openid --plugin=sidebar \
		--underlaydir=/dev/null --set deterministic=1 \
		--disable-plugin=shortcut --disable-plugin=smiley \
		--plugin=comments --set comments_pagespec="*" \
		--exclude='news/.*' --exclude='design/assistant/blog/*' \
		--exclude='bugs/*' --exclude='todo/*' --exclude='forum/*' \
		--exclude='users/*' --exclude='devblog/*'

clean:
	rm -rf tmp dist git-annex $(mans) configure  *.tix .hpc \
		doc/.ikiwiki html dist tags Build/SysConfig.hs \
		Setup Build/InstallDesktopFile Build/EvilSplicer \
		Build/Standalone Build/OSXMkLibs Build/LinuxMkLibs \
		Build/DistributionUpdate Build/BuildVersion \
		git-union-merge .tasty-rerun-log
	find . -name \*.o -exec rm {} \;
	find . -name \*.hi -exec rm {} \;

Build/InstallDesktopFile: Build/InstallDesktopFile.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/EvilSplicer: Build/EvilSplicer.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/Standalone: Build/Standalone.hs Build/SysConfig.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/OSXMkLibs: Build/OSXMkLibs.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs
Build/LinuxMkLibs: Build/LinuxMkLibs.hs
	$(GHC) --make $@ -Wall -fno-warn-tabs

sdist: clean mans
	./Build/make-sdist.sh

# Upload to hackage.
hackage: sdist
	@cabal upload dist/*.tar.gz

LINUXSTANDALONE_DEST=tmp/git-annex.linux
linuxstandalone:
	$(MAKE) git-annex linuxstandalone-nobuild
linuxstandalone-nobuild: Build/Standalone Build/LinuxMkLibs
	rm -rf "$(LINUXSTANDALONE_DEST)"
	mkdir -p tmp
	cp -R standalone/linux/skel "$(LINUXSTANDALONE_DEST)"
	
	install -d "$(LINUXSTANDALONE_DEST)/bin"
	cp dist/build/git-annex/git-annex "$(LINUXSTANDALONE_DEST)/bin/"
	strip "$(LINUXSTANDALONE_DEST)/bin/git-annex"
	ln -sf git-annex "$(LINUXSTANDALONE_DEST)/bin/git-annex-shell"
	zcat standalone/licences.gz > $(LINUXSTANDALONE_DEST)/LICENSE
	cp doc/logo_16x16.png doc/logo.svg $(LINUXSTANDALONE_DEST)
	cp standalone/trustedkeys.gpg $(LINUXSTANDALONE_DEST)

	./Build/Standalone "$(LINUXSTANDALONE_DEST)"
	
	install -d "$(LINUXSTANDALONE_DEST)/git-core"
	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(LINUXSTANDALONE_DEST)"/git-core && tar x)
	install -d "$(LINUXSTANDALONE_DEST)/templates"
	
	./Build/LinuxMkLibs "$(LINUXSTANDALONE_DEST)"
	
	$(MAKE) install-mans DESTDIR="$(LINUXSTANDALONE_DEST)"

	cd tmp/git-annex.linux && find . -type f > git-annex.MANIFEST
	cd tmp/git-annex.linux && find . -type l >> git-annex.MANIFEST
	cd tmp && tar c git-annex.linux | gzip -9 --rsyncable > git-annex-standalone-$(shell dpkg --print-architecture).tar.gz

# Run this target to build git-annex-standalone*.deb
debianstandalone: dpkg-buildpackage-F
# Run this target to build git-annex-standalone*.dsc
debianstandalone-dsc: dpkg-buildpackage-S

prep-standalone:
	$(MAKE) undo-standalone
	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build quilt push -a
	debian/create-standalone-changelog

undo-standalone:
	test -e .git
	git checkout debian/changelog
	quilt pop -a || true

commit-standalone:
	QUILT_PATCHES=debian/patches QUILT_SERIES=series.standalone-build  quilt refresh

dpkg-buildpackage%: prep-standalone
	umask 022; dpkg-buildpackage -rfakeroot $*
	$(MAKE) undo-standalone

OSXAPP_DEST=tmp/build-dmg/git-annex.app
OSXAPP_BASE=$(OSXAPP_DEST)/Contents/MacOS/bundle
osxapp: Build/Standalone Build/OSXMkLibs
	$(MAKE) git-annex

	rm -rf "$(OSXAPP_DEST)" "$(OSXAPP_BASE)"
	install -d tmp/build-dmg
	cp -R standalone/osx/git-annex.app "$(OSXAPP_DEST)"

	install -d "$(OSXAPP_BASE)"
	cp git-annex "$(OSXAPP_BASE)"
	strip "$(OSXAPP_BASE)/git-annex"
	ln -sf git-annex "$(OSXAPP_BASE)/git-annex-shell"
	gzcat standalone/licences.gz > $(OSXAPP_BASE)/LICENSE
	cp $(OSXAPP_BASE)/LICENSE tmp/build-dmg/LICENSE.txt
	cp standalone/trustedkeys.gpg $(OSXAPP_DEST)/Contents/MacOS

	./Build/Standalone $(OSXAPP_BASE)

	(cd "$(shell git --exec-path)" && tar c .) | (cd "$(OSXAPP_BASE)" && tar x)
	install -d "$(OSXAPP_BASE)/templates"

	# OSX looks in man dir nearby the bin
	$(MAKE) install-mans DESTDIR="$(OSXAPP_BASE)/.." SHAREDIR="" PREFIX=""

	./Build/OSXMkLibs $(OSXAPP_BASE)
	cd $(OSXAPP_DEST) && find . -type f > Contents/MacOS/git-annex.MANIFEST
	cd $(OSXAPP_DEST) && find . -type l >> Contents/MacOS/git-annex.MANIFEST
	rm -f tmp/git-annex.dmg
	hdiutil create -format UDBZ -size 640m -srcfolder tmp/build-dmg \
		-volname git-annex -o tmp/git-annex.dmg

ANDROID_FLAGS?=
# Cross compile for Android.
# Uses https://github.com/neurocyte/ghc-android
android: Build/EvilSplicer
	echo "Running native build, to get TH splices.."
	if [ ! -e dist/setup/setup ]; then $(CABAL) configure -f-Production -O0 $(ANDROID_FLAGS) -fAndroidSplice;  fi
	mkdir -p tmp
	if ! $(CABAL) build --ghc-options=-ddump-splices 2> tmp/dump-splices; then tail tmp/dump-splices >&2; exit 1; fi
	echo "Setting up Android build tree.."
	./Build/EvilSplicer tmp/splices tmp/dump-splices standalone/no-th/evilsplicer-headers.hs
	rsync -az --exclude tmp --exclude dist . tmp/androidtree
# Copy the files with expanded splices to the source tree, but
# only if the existing source file is not newer. (So, if a file
# used to have TH splices but they were removed, it will be newer,
# and not overwritten.)
	cp -uR tmp/splices/* tmp/androidtree || true
# Some additional dependencies needed by the expanded splices.
	sed -i 's/^  Build-Depends: */  Build-Depends: yesod-core, yesod-routes, shakespeare, blaze-markup, file-embed, wai-app-static, wai, unordered-containers, /' tmp/androidtree/git-annex.cabal
# Avoid warnings due to sometimes unused imports added for the splices.
	sed -i 's/GHC-Options: \(.*\)-Wall/GHC-Options: \1-Wall -fno-warn-unused-imports /i' tmp/androidtree/git-annex.cabal
	sed -i 's/Extensions: /Extensions: MagicHash /i' tmp/androidtree/git-annex.cabal
# Cabal cannot cross compile with custom build type, so workaround.
	sed -i 's/Build-type: Custom/Build-type: Simple/' tmp/androidtree/git-annex.cabal
# Build just once, but link repeatedly, for different versions of Android.
	mkdir -p tmp/androidtree/dist/build/git-annex/4.0 tmp/androidtree/dist/build/git-annex/4.3 tmp/androidtree/dist/build/git-annex/5.0
	if [ ! -e tmp/androidtree/dist/setup-config ]; then \
		cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal configure -fAndroid $(ANDROID_FLAGS); \
	fi
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/4.0/git-annex
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		--ghc-options=-optl-z --ghc-options=-optlnocopyreloc \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/4.3/git-annex
	cd tmp/androidtree && $$HOME/.ghc/$(shell cat standalone/android/abiversion)/arm-linux-androideabi/bin/cabal build \
		--ghc-options=-optl-z --ghc-options=-optlnocopyreloc --ghc-options=-optl-fPIE --ghc-options=-optl-pie --ghc-options=-optc-fPIE --ghc-options=-optc-pie \
		&& mv dist/build/git-annex/git-annex dist/build/git-annex/5.0/git-annex

androidapp:
	$(MAKE) android
	$(MAKE) -C standalone/android

# We bypass cabal, and only run the main ghc --make command for a
# fast development built. Note: Does not rebuild C libraries, or link
# executable.
fast: dist/caballog
	@$$(grep 'ghc --make' dist/caballog | head -n 1 | sed -e 's/-package-id [^ ]*//g' -e 's/-hide-all-packages//') -O0
	@ln -sf dist/build/git-annex/git-annex git-annex
	@$(MAKE) tags >/dev/null 2>&1 &

dist/caballog: git-annex.cabal
	$(CABAL) configure -f"-Production" -O0 --enable-executable-dynamic
	$(CABAL) build -v2 | tee $@

# Hardcoded command line to make hdevtools start up and work.
# You will need some memory. It's worth it.
# Note: Don't include WebDAV or Webapp. TH use bloats memory > 500 mb!
# TODO should be possible to derive this from caballog.
hdevtools:
	hdevtools --stop-server || true
	hdevtools check git-annex.hs -g -cpp -g -i -g -idist/build/git-annex/git-annex-tmp -g -i. -g -idist/build/autogen -g -Idist/build/autogen -g -Idist/build/git-annex/git-annex-tmp -g -IUtility -g -DWITH_TESTSUITE -g -DWITH_S3 -g -DWITH_ASSISTANT -g -DWITH_INOTIFY -g -DWITH_DBUS -g -DWITH_PAIRING -g -DWITH_XMPP -g -optP-include -g -optPdist/build/autogen/cabal_macros.h -g -odir -g dist/build/git-annex/git-annex-tmp -g -hidir -g dist/build/git-annex/git-annex-tmp -g -stubdir -g dist/build/git-annex/git-annex-tmp -g -threaded -g -Wall -g -XHaskell98 -g -XPackageImports

distributionupdate:
	git pull
	cabal configure
	ghc -Wall --make Build/DistributionUpdate -XPackageImports -optP-include -optPdist/build/autogen/cabal_macros.h
	./Build/DistributionUpdate

.PHONY: git-annex git-union-merge tags

=== debian/changelog ===
git-annex (5.20150812-2) unstable; urgency=medium

  * Override lintian errors

 -- Richard Hartmann <richih@debian.org>  Sat, 15 Aug 2015 02:02:00 +0200

git-annex (5.20150812-1) unstable; urgency=medium

  * Package 5.20150812-1

 -- Richard Hartmann <richih@debian.org>  Thu, 13 Aug 2015 20:47:58 +0200

git-annex (5.20150812) unstable; urgency=medium

  * Added support for SHA3 hashed keys (in 8 varieties), when git-annex is
    built using the cryptonite library.
  * metadata: Fix reversion introduced in 5.20150727 that caused recursive
    display of metadata to not work.
  * Windows: Fix bug that caused git-annex sync to fail due to missing
    environment variable.
  * Fix setting/setting/viewing metadata that contains unicode or other
    special characters, when in a non-unicode locale.
  * Simplify setup process for a ssh remote. Now it suffices to run git
    remote add, followed by git-annex sync. Now the remote is automatically
    initialized for use by git-annex, where before the git-annex branch had
    to manually be pushed before using git-annex sync. Note that this
    involved changes to git-annex-shell, so if the remote is using an old
    version, the manual push is still needed.
  * git-annex-shell: Don't let configlist auto-init repository when in
    readonly mode.
  * Perform a clean shutdown when --time-limit is reached.
    This includes running queued git commands, and cleanup actions normally
    run when a command is finished.
  * fsck: Commit incremental fsck database when --time-limit is reached.
    Previously, some of the last files fscked did not make it into the
    database when using --time-limit.
  * fsck: Commit incremental fsck database after every 1000 files
    fscked, or every 5 minutes, whichever comes first. Previously,
    commits were made every 1000 files fscked.
  * Linux standalone: Work around problem that prevented it from working
    properly if unpacked into a directory that contains ":" or ";" in its
    name.
  * proxy: Fix proxy git commit of non-annexed files in direct mode. 
  * proxy: If a non-proxied git command, such as git revert
    would normally fail because of unstaged files in the work tree,
    make the proxied command fail the same way.
  * proxy: Fix removal of files deleted by the proxied command.
  * proxy: Fix behavior when run in subdirectory of git repo.
  * Improve Setup.hs file so that cabal copy --destdir works.
    Thanks, Magnus Therning.
  * Tighten dependency on optparse-applicative to 0.11.0.
  * Added back debian/cabal-wrapper, since it still seems needed after all.

 -- Joey Hess <id@joeyh.name>  Wed, 12 Aug 2015 11:14:58 -0400

=== debian/control ===
--- 
+++ 
@@ -4,12 +4,13 @@
 Build-Depends: 
 	debhelper (>= 9),
 	ghc (>= 7.4),
+	cabal-install,
 	libghc-mtl-dev (>= 2.1.1),
 	libghc-missingh-dev,
 	libghc-data-default-dev,
 	libghc-hslogger-dev,
 	libghc-pcre-light-dev,
-	libghc-cryptohash-dev (>= 0.11.0),
+	libghc-cryptonite-dev | libghc-cryptohash-dev (>= 0.11.0),
 	libghc-sandi-dev,
 	libghc-utf8-string-dev,
 	libghc-aws-dev (>= 0.9.2-2~),
@@ -80,8 +81,7 @@
 	curl,
 	openssh-client,
 	git-remote-gcrypt (>= 0.20130908-6),
-Maintainer: Ubuntu Developers <ubuntu-devel-discuss@lists.ubuntu.com>
-XSBC-Original-Maintainer: Richard Hartmann <richih@debian.org>
+Maintainer: Richard Hartmann <richih@debian.org>
 Standards-Version: 3.9.6
 Vcs-Git: git://git.kitenet.net/git-annex
 Homepage: http://git-annex.branchable.com/

## git-annex 5.20150824

=== Makefile ===
--- 
+++ 
@@ -16,7 +16,7 @@
 
 Build/SysConfig.hs: configure.hs Build/TestConfig.hs Build/Configure.hs
 	if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
-	$(CABAL) configure
+	$(CABAL) configure --ghc-options="$(shell Build/collect-ghc-options.sh)"
 
 git-annex: Build/SysConfig.hs
 	$(CABAL) build
@@ -81,7 +81,7 @@
 		--plugin=comments --set comments_pagespec="*" \
 		--exclude='news/.*' --exclude='design/assistant/blog/*' \
 		--exclude='bugs/*' --exclude='todo/*' --exclude='forum/*' \
-		--exclude='users/*' --exclude='devblog/*'
+		--exclude='users/*' --exclude='devblog/*' --exclude='thanks'
 
 clean:
 	rm -rf tmp dist git-annex $(mans) configure  *.tix .hpc \

=== debian/changelog ===
git-annex (5.20150824-1) unstable; urgency=medium

  * Package 5.20150824-1

 -- Richard Hartmann <richih@debian.org>  Sun, 13 Sep 2015 22:02:06 +0200

git-annex (5.20150824) unstable; urgency=medium

  * Sped up downloads of files from ssh remotes, reducing the
    non-data-transfer overhead 6x.
  * sync: Support --jobs
  * sync --content: Avoid unnecessary second pull from remotes when 
    no file transfers are made.
  * External special remotes can now be built that can be used in readonly
    mode, where git-annex downloads content from the remote using regular
    http.
  * Added WHEREIS to external special remote protocol.
  * importfeed --relaxed: Avoid hitting the urls of items in the feed.
  * Fix reversion in init when ran as root, introduced in version 5.20150731.
  * Reorder declaration to fix build with yesod-core > 1.4.13.
    Thanks, Michael Alan Dorman.
  * Fix building without quvi and without database.
    Thanks, Ben Boeckel.
  * Avoid building the assistant on the hurd, since an inotify equivalent
    is not yet implemented in git-annex for the hurd.
  * --debug log messages are now timestamped with fractional seconds.
  * --debug is passed along to git-annex-shell when git-annex is in debug mode.
  * Makefile: Pass LDFLAGS, CFLAGS, and CPPFLAGS through ghc and on to
    ld, cc, and cpp.
  * As a result of the Makefile changes, the Debian package is built
    with various hardening options. Although their benefit to a largely
    haskell program is unknown.

 -- Joey Hess <id@joeyh.name>  Mon, 24 Aug 2015 14:11:05 -0700

=== debian/control ===
--- 
+++ 
@@ -32,17 +32,17 @@
 	libghc-stm-dev (>= 2.3),
 	libghc-dbus-dev (>= 0.10.7) [linux-any],
 	libghc-fdo-notify-dev (>= 0.3) [linux-any],
-	libghc-yesod-dev (>= 1.2.6.1)       [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
-	libghc-yesod-core-dev (>= 1.2.19)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
-	libghc-yesod-form-dev (>= 1.3.15)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
-	libghc-yesod-static-dev (>= 1.2.4)  [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
-	libghc-yesod-default-dev (>= 1.2.0) [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
-	libghc-shakespeare-dev (>= 2.0.0)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
-	libghc-clientsession-dev            [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
-	libghc-warp-dev (>= 3.0.0.5)        [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
-	libghc-warp-tls-dev                 [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
-	libghc-wai-dev                      [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
-	libghc-wai-extra-dev                [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
+	libghc-yesod-dev (>= 1.2.6.1)       [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
+	libghc-yesod-core-dev (>= 1.2.19)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
+	libghc-yesod-form-dev (>= 1.3.15)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
+	libghc-yesod-static-dev (>= 1.2.4)  [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
+	libghc-yesod-default-dev (>= 1.2.0) [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
+	libghc-shakespeare-dev (>= 2.0.0)   [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
+	libghc-clientsession-dev            [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
+	libghc-warp-dev (>= 3.0.0.5)        [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
+	libghc-warp-tls-dev                 [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
+	libghc-wai-dev                      [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
+	libghc-wai-extra-dev                [i386 amd64 armel armhf armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x],
 	libghc-dav-dev (>= 1.0)             [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
 	libghc-persistent-dev               [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],
 	libghc-persistent-template-dev      [i386 amd64 arm64 armel armhf kfreebsd-i386 kfreebsd-amd64 powerpc ppc64el s390x hurd-i386],

## git-annex 5.20151019

=== Makefile ===
--- 
+++ 
@@ -200,7 +200,7 @@
 # Uses https://github.com/neurocyte/ghc-android
 android: Build/EvilSplicer
 	echo "Running native build, to get TH splices.."
-	if [ ! -e dist/setup/setup ]; then $(CABAL) configure -f-Production -O0 $(ANDROID_FLAGS) -fAndroidSplice;  fi
+	if [ ! -e dist/setup/setup ]; then $(CABAL) configure -O0 $(ANDROID_FLAGS) -fAndroidSplice;  fi
 	mkdir -p tmp
 	if ! $(CABAL) build --ghc-options=-ddump-splices 2> tmp/dump-splices; then tail tmp/dump-splices >&2; exit 1; fi
 	echo "Setting up Android build tree.."
@@ -240,7 +240,7 @@
 # fast development built. Note: Does not rebuild C libraries, or link
 # executable.
 fast: dist/caballog
-	@$$(grep 'ghc --make' dist/caballog | head -n 1 | sed -e 's/-package-id [^ ]*//g' -e 's/-hide-all-packages//') -O0
+	@$$(grep 'ghc --make' dist/caballog | head -n 1 | sed -e 's/-package-id [^ ]*//g' -e 's/-hide-all-packages//') -O0 -j -dynamic
 	@ln -sf dist/build/git-annex/git-annex git-annex
 	@$(MAKE) tags >/dev/null 2>&1 &

## git-annex 5.20151116

=== debian/changelog ===
git-annex (5.20151116-1) unstable; urgency=medium

  * Package 5.20151116-1

 -- Richard Hartmann <richih@debian.org>  Sat, 28 Nov 2015 10:19:20 +0100

git-annex (5.20151116) unstable; urgency=medium

  * Use concurrent-output library when configured with -fConcurrentOutput.
    This allows nicely displayed messages when using the -J flag.
  * Additional commands now support the -J flag: 
    fsck, drop, add, addurl, import
  * import: Avoid very ugly error messages when the directory files
    are imported to is not a directort, but perhaps an annexed file.
  * Concurrent progress bars are now displayed when using -J with a command
    that moves file contents around.
  * Fix race that could result in an annexed file's symlink not being
    created, when eg, running concurrent git-annex adds.
  * add: Fix error recovery rollback to not move the injested file content
    out of the annex back to the file, because other files may point to
    that same content. Instead, copy the injected file content out to
    recover.
  * quvi may output utf-8 encoded data when the conifigured locale doesn't
    support that; avoid crashing on such invalid encoding.
  * runshell: Avoid failing when $HOME/.ssh does not exist and cannot be
    created.
  * Make the git-annex-standalone.deb prevent runshell from installing
    wrappers into $HOME/.ssh
  * Make git-annex-standalone.deb include the git-annex html documentation,
    desktop file, and base completion file, same as the regular git-annex.deb.
  * fsck: When fscking a dead repo, avoid incorrect "fixing location log"
    message, and display a warning about it being dead, since it's unusual
    to have access to a dead repo.
  * assistant: Pass ssh-options through 3 more git pull/push calls
    that were missed before.
  * Added annex.pidlock and annex.pidlocktimeout configuration to support
    filesystems where POSIX fcntl locks cannot be used.
  * init: Automatically enable annex.pidlock when necessary.

 -- Joey Hess <id@joeyh.name>  Mon, 16 Nov 2015 14:17:40 -0400

git-annex (5.20151102.1) unstable; urgency=medium

  * Avoid installing desktop file and program file if cabal install
    git-annex is run as root, since that is not a systemwide install,
    but to /root, and so generating a systemwide desktop file is not right.
  * When cabal install is run with the desktop file location not writable,
    display a warning, but continue successfully.

 -- Joey Hess <id@joeyh.name>  Tue, 03 Nov 2015 12:08:38 -0400

git-annex (5.20151102) unstable; urgency=medium

  * Use statvfs on OSX.
  * Symlink timestamp preservation code uses functions
    from unix-2.7.0 when available, which should be more portable.
  * enableremote: List uuids and descriptions of remotes that can be
    enabled, and accept either the uuid or the description in leu if the
    name.
  * Catch up with current git behavior when both repo and repo.git exist;
    it seems it now prefers repo in this case, although historically it may
    have preferred repo.git.
  * Fix failure to build with aws-0.13.0.
  * When built with aws-0.13.0, the S3 special remote can be used to create
    google nearline buckets, by setting storageclass=NEARLINE.

 -- Joey Hess <id@joeyh.name>  Mon, 02 Nov 2015 12:41:20 -0400

git-annex (5.20151019-1) unstable; urgency=medium

  * Package 5.20151019-1

 -- Richard Hartmann <richih@debian.org>  Mon, 19 Oct 2015 21:54:57 +0200

git-annex (5.20151019) unstable; urgency=medium

  * Fix a longstanding, but unlikely to occur bug, where dropping
    a file from a remote could race with other drops of the same file,
    and result in all copies of its content being lost.
  * git-annex-shell: Added lockcontent command, to prevent dropping of
    a key's content. This is necessary due to the above bugfix.
  * In some cases, the above bugfix changes what git-annex allows you to
    drop:
    - When a file is present in several special remotes,
      but not in any accessible git repositories, dropping it from one of
      the special remotes will now fail. Instead, the file has to be
      moved from one of the special remotes to the git repository, and can
      then safely be dropped from the git repository.
    - If a git remote has too old a version of git-annex-shell installed,
      git-annex won't trust it to hold onto a copy of a file when dropping
      that file from the local git repository.
  * Changed drop ordering when using git annex sync --content or the
    assistant, to drop from remotes first and from the local repo last.
    This works better with the behavior changes to drop in many cases.
  * Do verification of checksums of annex objects downloaded from remotes.
  * When annex objects are received into git repositories from other git
    repos, their checksums are verified then too.
  * To get the old, faster, behavior of not verifying checksums, set
    annex.verify=false, or remote.<name>.annex-verify=false.
  * setkey, rekey: These commands also now verify that the provided file
    matches the expected checksum of the key, unless annex.verify=false.
  * reinject: Already verified content; this can now be disabled by
    setting annex.verify=false.
  * sync, merge, assistant: When git merge failed for a reason other
    than a conflicted merge, such as a crippled filesystem not allowing
    particular characters in filenames, git-annex would make a merge commit
    that could omit such files or otherwise be bad. Fixed by aborting the
    whole merge process when git merge fails for any reason other than a
    merge conflict.
  * Allow building with S3 disabled again.
  * Ported disk free space checking code to work on Solaris.
  * Windows webapp: Fix support for entering password when setting
    up a ssh remote.
  * copy --auto was checking the wrong repo's preferred content.
    (--from was checking what --to should, and vice-versa.)
    Fixed this bug, which was introduced in version 5.20150727.


=== debian/rules ===
#!/usr/bin/make -f

export CABAL=debian/cabal-wrapper

STANDALONE_BUILD=$(shell grep -qe '^Package: git-annex-standalone' debian/control \
                         && echo 1 || echo 0)

# Do use the changelog's version number, rather than making one up.
export RELEASE_BUILD=1

%:
	dh $@


# Standalone build logic/helpers
ifeq ($(STANDALONE_BUILD),1)

override_dh_auto_build:
	make linuxstandalone GIT_ANNEX_PACKAGE_INSTALL=1

override_dh_auto_install:
	make install-misc install-docs DESTDIR=debian/git-annex-standalone
	# bins are linked into place, as instructed in debian/install and debian/links

override_dh_fixperms:
	dh_fixperms -Xld-linux

endif

## git-annex 5.20151208

=== Makefile ===
--- 
+++ 
@@ -18,8 +18,9 @@
 	if [ "$(CABAL)" = ./Setup ]; then ghc --make Setup; fi
 	$(CABAL) configure --ghc-options="$(shell Build/collect-ghc-options.sh)"
 
+# -j1 is used for reproducible build
 git-annex: Build/SysConfig.hs
-	$(CABAL) build
+	$(CABAL) build -j1
 	ln -sf dist/build/git-annex/git-annex git-annex
 
 man/%.1: doc/%.mdwn
@@ -41,13 +42,17 @@
 		rsync -a --delete html/ $(DESTDIR)$(PREFIX)/$(SHAREDIR)/doc/git-annex/html/; \
 	fi
 
-install: build install-docs Build/InstallDesktopFile
+install-bins: build
 	install -d $(DESTDIR)$(PREFIX)/bin
 	install git-annex $(DESTDIR)$(PREFIX)/bin
 	ln -sf git-annex $(DESTDIR)$(PREFIX)/bin/git-annex-shell
+
+install-misc: Build/InstallDesktopFile
 	./Build/InstallDesktopFile $(PREFIX)/bin/git-annex || true
 	install -d $(DESTDIR)$(PREFIX)/share/bash-completion/completions
 	install -m 0644 bash-completion.bash $(DESTDIR)$(PREFIX)/share/bash-completion/completions/git-annex
+
+install: install-bins install-docs install-misc
 
 test: git-annex
 	./git-annex test
@@ -118,6 +123,7 @@
 	rm -rf "$(LINUXSTANDALONE_DEST)"
 	mkdir -p tmp
 	cp -R standalone/linux/skel "$(LINUXSTANDALONE_DEST)"
+	sed -i -e 's/^GIT_ANNEX_PACKAGE_INSTALL=/GIT_ANNEX_PACKAGE_INSTALL=$(GIT_ANNEX_PACKAGE_INSTALL)/' "$(LINUXSTANDALONE_DEST)/runshell"
 	
 	install -d "$(LINUXSTANDALONE_DEST)/bin"
 	cp dist/build/git-annex/git-annex "$(LINUXSTANDALONE_DEST)/bin/"
@@ -237,8 +243,7 @@
 	$(MAKE) -C standalone/android
 
 # We bypass cabal, and only run the main ghc --make command for a
-# fast development built. Note: Does not rebuild C libraries, or link
-# executable.
+# fast development built.
 fast: dist/caballog
 	@$$(grep 'ghc --make' dist/caballog | head -n 1 | sed -e 's/-package-id [^ ]*//g' -e 's/-hide-all-packages//') -O0 -j -dynamic
 	@ln -sf dist/build/git-annex/git-annex git-annex

=== standalone/android/Makefile ===
# Cross-compiles utilities needed for git-annex on Android,
# and builds the Android app.

build:
	./buildapk 4
	./buildapk 5

# Targets below are used by buildapk, which sets
# GIT_ANNEX_ANDROID_SOURCETREE

source: $(GIT_ANNEX_ANDROID_SOURCETREE)

$(GIT_ANNEX_ANDROID_SOURCETREE):
	mkdir -p $(GIT_ANNEX_ANDROID_SOURCETREE)
	git clone git://git.debian.org/git/d-i/busybox $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox
	git clone git://git.kernel.org/pub/scm/git/git.git $(GIT_ANNEX_ANDROID_SOURCETREE)/git
	git clone git://git.samba.org/rsync.git $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync
	git clone git://git.gnupg.org/gnupg.git $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg
	git clone git://git.openssl.org/openssl $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl
	git clone git://github.com/CyanogenMod/android_external_openssh.git $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh
	git clone git://github.com/jackpal/Android-Terminal-Emulator.git $(GIT_ANNEX_ANDROID_SOURCETREE)/term

$(GIT_ANNEX_ANDROID_SOURCETREE)/openssl/build-stamp:
	# This is a version which the openssh below can build with.
	# Newer versions changed something to do with BIGNUM.
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl && git reset --hard 616f71e486d693991b594439c884ec624b32c2d4
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl && CC=$$(which cc) ./Configure android
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssl && $(MAKE)
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/build-stamp: openssh.patch openssh.config.h
	# This is a known-good version that the patch works with.
	# TODO: Upgrade
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && git reset --hard 0a8617ed5af2f0248d0e9648e26b224e16ada742
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && ./configure --host=arm-linux-androideabi --with-ssl-dir=../openssl --without-openssl-header-check
	cat openssh.patch | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && patch -p1)
	cp openssh.config.h $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh/config.h
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && sed -i -e 's/getrrsetbyname.o //' openbsd-compat/Makefile
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && sed -i -e 's/auth-passwd.o //' Makefile
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/openssh && $(MAKE) ssh ssh-keygen
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/build-stamp: busybox_config
	cp busybox_config $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox/.config
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox && git reset --hard a758e3e1e04e7705f5d37b2f27be654cd0e7282c
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox && yes '' | $(MAKE) oldconfig
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/busybox && $(MAKE)
	touch $@
	
$(GIT_ANNEX_ANDROID_SOURCETREE)/git/build-stamp: git.patch
	# This is a known-good version that the patch works with.
	cat git.patch | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/git && git reset --hard f9dc5d65ca31cb79893e1296efe37727bf58f3f3 && git am)
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/git && $(MAKE) install NO_OPENSSL=1 NO_GETTEXT=1 NO_GECOS_IN_PWENT=1 NO_GETPASS=1 NO_NSEC=1 NO_MKDTEMP=1 NO_PTHREADS=1 NO_PERL=1 NO_CURL=1 NO_EXPAT=1 NO_TCLTK=1 NO_ICONV=1 HAVE_CLOCK_GETTIME= prefix= DESTDIR=installed-tree
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/rsync/build-stamp: rsync.patch
	# This is a known-good version that the patch works with.
	cat rsync.patch | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync && git reset --hard eec26089b1c7bdbb260674480ffe6ece257bca63 && git am)
	cp /usr/share/misc/config.sub /usr/share/misc/config.guess $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync/
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync && ./configure --host=arm-linux-androideabi --disable-locale --disable-iconv-open --disable-iconv --disable-acl-support --disable-xattr-support
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/rsync && $(MAKE)
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg/build-stamp:
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg && git checkout gnupg-1.4.15
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg && ./autogen.sh
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg && ./configure --host=arm-linux-androideabi --disable-gnupg-iconv --disable-card-support --disable-agent-support --disable-photo-viewers --disable-keyserver-helpers --disable-nls
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/gnupg; $(MAKE) || true # expected failure in doc build
	touch $@

$(GIT_ANNEX_ANDROID_SOURCETREE)/term/build-stamp: term.patch icons
	# This is a known-good version that the patch works with.
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && git reset --hard 3d34b3c42295c215b62e70f3ee696dd664ba08ce
	cat term.patch | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && patch -p1)
	(cd icons && tar c .) | (cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term/res && tar x)
	# This renaming has a purpose. It makes the path to the app's
	# /data directory shorter, which makes ssh connection caching
	# sockets placed there have more space for their filenames.
	# Also, it avoids overlap with the Android Terminal Emulator
	# app, if it's also installed.
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && find -name .git -prune -o -type f -print0 | xargs -0 perl -pi -e 's/jackpal/ga/g'
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && perl -pi -e 's/Terminal Emulator/Git Annex/g' res/*/strings.xml
	cd $(GIT_ANNEX_ANDROID_SOURCETREE)/term && echo y | tools/update.sh || true
	touch $@

=== debian/changelog ===
git-annex (5.20151208-1build1) xenial; urgency=medium

  * No-change rebuild for gnutls transition.

 -- Matthias Klose <doko@ubuntu.com>  Wed, 17 Feb 2016 22:25:06 +0000

git-annex (5.20151208-1) unstable; urgency=medium

  * Package 5.20151208-1

 -- Richard Hartmann <richih@debian.org>  Wed, 09 Dec 2015 13:07:41 +0100

git-annex (5.20151208) unstable; urgency=medium

  * Build with -j1 again to get reproducible build.
  * Display progress meter in -J mode when copying from a local git repo,
    to a local git repo, and from a remote git repo.
  * Display progress meter in -J mode when downloading from the web.
  * map: Improve display of git remotes with non-ssh urls, including http
    and gcrypt. 
  * When core.sharedRepository is set, annex object files are not made mode
    444, since that prevents a user other than the file owner from locking
    them. Instead, a mode such as 664 is used in this case.
  * tahoe: Include tahoe capabilities in whereis display.
  * import: Changed to honor annex.largefiles settings.
  * addurl, importfeed: Changed to honor annex.largefiles settings,
    when the content of the url is downloaded. (Not when using --fast or
    --relaxed.)
  * webapp: Fix bugs that could result in a relative path such as "."
    being written to ~/.config/git-annex/autostart, and ignore any such 
    relative paths in the file.
    This was a reversion caused by the relative path changes in 5.20150113.
  * dropunused: Make more robust when trying to drop an object that has
    already been dropped.
  * Fix reversion in handling of long filenames, particularly when using
    addurl/importfeed, which was introduced in the previous release.

 -- Joey Hess <id@joeyh.name>  Tue, 08 Dec 2015 11:14:03 -0400

=== debian/control ===
--- 
+++ 
@@ -19,7 +19,6 @@
 	libghc-quickcheck2-dev,
 	libghc-monad-control-dev (>= 0.3),
 	libghc-exceptions-dev (>= 0.6),
-	libghc-transformers-dev,
 	libghc-unix-compat-dev,
 	libghc-dlist-dev,
 	libghc-uuid-dev,
@@ -70,8 +69,9 @@
 	libghc-tasty-hunit-dev,
 	libghc-tasty-quickcheck-dev,
 	libghc-tasty-rerun-dev,
-	libghc-optparse-applicative-dev (>= 0.10),
+	libghc-optparse-applicative-dev (>= 0.11.0),
 	libghc-cabal-dev,
+	libghc-torrent-dev,
 	lsof [linux-any],
 	ikiwiki,
 	perlmagick,
@@ -104,7 +104,6 @@
 	git-remote-gcrypt (>= 0.20130908-6),
 	nocache,
 	aria2,
-	bittornado | bittorrent,
 Suggests:
 	graphviz,
 	bup,
